def fn read_options_error% (change_item_settings%)
rem reads the options from the linker control file and sets the different reps
rem returns 0 if no error, else an error
rem changes the item statuses if change_item_settings% <>0
rem
rem uses global vars default_input_di$, defaultoutput_dir$,errfile$,
rem line_number%,line_increase%, p_to_l$,l_to_p$, job_name$,output_file$
rem version$,addversion%  -  AND ALSO SETS THEM
rem also uses global vars subwinarray$; modulefile$,linenumber$
rem v. 1.02
local lp%,opt%,option$,to_set$,counter%,is_eror%,line$,inchan%
  default_input_dir$=GENERL(1)		: rem set default values
  default_output_dir$=GENERL(2)
  errfile$='error_file'
  p_to_l$="p_to_l":l_to_p$="l_to_p"
  line_number%=10:line_increase%=10:start_line%=10
  job_name$=""
  output_file$=""
  version$="":addversion%=0
  counter%=1:is_eror%=0
  dim subwinarray$(80,80),modulefile$(80,40),linenumber$(80,5):counter%=1
  pe_print#scr_chan%, info_message$(15)&cr$&' '&in_file$ : rem say hello
  inchan%=fop_in(in_file$)		: rem try to open file
  IF inchan%<0:RETurn inchan%		: rem couldn't even open it!
  if not get_start_of_section%(startoptions$,inchan%)
    close#inchan%			: rem find options section **--OPTIONS--**
    return 0				: rem if none, just leave OK
  endif
  REPeat lp%
    if eof(#inchan%)
       subwinarray$(counter%)=make_length$(endoption$,39)&" : "&error_message$(7)
       modulefile$(counter%)=in_file$	: rem there was no end of options marker
       close#inchan%
       return 1
    endif
    INPUT#inchan%,line$ 		: rem get a line
    line_in_file%=line_in_file%+1	: rem one line further down in the file
    line$=exp_tabs$(line$,tab_spaces%)	: rem expand possible tabs to spaces
    if line$="":next lp%:exit lp%	: rem if empty line, do nothing
    IF line$==endoption$:EXIT lp%	: rem if end of options, leave
    opt%="/" instr line$		: rem see if there is a comment in line
    if opt%
      if opt%=1:NEXT lp%:EXIT lp%	: rem whole line is a comment - ignore
      line$=strip_spaces$(line$(1 to opt%-1)) : rem get rid of spaces
    endif
    opt%="="INSTR line$ 		: rem option must be followed by "="
    IF NOT opt%
       subwinarray$(counter%)=make_length$(line$,39)&error_message$(24)
       modulefile$(counter%)=in_file$	: rem there was no "="!
       linenumber$(counter%)=line_in_file%
       counter%=counter%+1
       is_eror%=1:next lp%
    endif
    to_set$=strip_spaces$(line$(1 TO opt%-1)) : rem option to set
    if opt%=len(line$)
      next lp%				: rem no option after the "=" - ignore
    else
      option$=strip_spaces$(line$(opt%+1 TO LEN(line$))) : rem get option setting
    endif
    if option$="": next lp%	: rem no option after the "="
:
    if to_set$=='indir'    : default_input_dir$=option$:next lp%
    if to_set$=='outdir'   : default_output_dir$=option$:next lp%
    if to_set$=='file'	   : output_file$=option$:next lp%
    if to_set$=='errfile'  : errfile$=option$:next lp%
    if to_set$=='proc_to_line': p_to_l$=option$:next lp%
    if to_set$=='line_to_proc': l_to_p$=option$:next lp%
    if to_set$=='startline': line_number%=option$:start_line%=line_number%:next lp%
    if to_set$=='increase' : line_increase%=option$:next lp%
    if to_set$=='job_name' : job_name$=option$:next lp%
    if to_set$=='version'  : version$=option$:next lp%
    if to_set$=='addversion'
	if option$=='yes'
	  addversion%=1
	else
	  addversion%=0
	endif
	next lp%
    endif
    if to_set$=='concat_char' : concat$=option$:next lp%
    if to_set$=='do_concat'
	if option$=='yes'
	  concat_lines%=1
	else
	  concat_lines%=0
	endif
	next lp%
    endif
    if to_set$=='parse'
       if change_item_settings%:main_lfl%(check_it%)=1+128*(option$=='yes')
       next lp%
    endif
    if to_set$=='compile'
       if change_item_settings%:main_lfl%(comp_it%)=1+128*(option$=='yes')
	next lp%
    endif
    if to_set$=='execute'
       if change_item_settings%:main_lfl%(exec_it%)=1+128*(option$=='yes')
       next lp%
    endif
:	rem if we ever get here, we have an unrecognized option
    subwinarray$(counter%)=make_length$(to_set$,39)&error_message$(25)
    modulefile$(counter%)=in_file$
    counter%=counter%+1
    is_eror%=1
  end rep lp%
  if not is_eror%
    is_eror%=errors_in_compiler_options% : rem try to preset comp options
  endif
  close#inchan%
  return is_eror%
end def read_options_error%
:
